#include "child.h"
#include <sys/signal.h>

Child::Child( const char *name, char * const*argv )
{
   int pfrom[2], pto[2];

   pipe( pfrom );
   pipe( pto );
   pid = fork();
   if (pid == 0) // Child
     {
	dup2( pto[0], 0 );
	dup2( pfrom[1], 1 );
	close( pto[0] );
	close( pto[1] );
	close( pfrom[0] );
	close( pfrom[1] );
	
	execvp( name, argv );
     }
   
   close( pto[0] );
   close( pfrom[1] );
   fd_from=pfrom[0];
   fd_to=pto[1];

   FD_ZERO( &rfds );
   FD_SET( fd_from, &rfds );
}
   
Child::~Child()
{
  close( fd_to );
  close( fd_from );
  kill( pid, 9 );
}

int Child::ready()
{
   struct timeval tv;


   
   tv.tv_sec=0;
   tv.tv_usec=0; 
   
   FD_ZERO( &rfds );
   FD_SET( fd_from, &rfds );
   
   return select( fd_from+1, &rfds, 0, 0, &tv );
}















