#ifndef MAINWIN_H
#define MAINWIN_H

#include <qwidget.h>
#include <qlined.h>
#include "child.h"

class QMultiLineEdit;
class QListBox;
class QStrList;
class QCheckBox;

class CmdLine : public QLineEdit
{
  QStrList *history;
  uint hpos;

 public:
  CmdLine( QWidget * parent = 0, const char * name = 0);
  ~CmdLine();
  void addHis( QString );
  
 protected:
  void keyPressEvent( QKeyEvent * );

};

struct info 
{
  int a_salut, l_salut, a_beep, i_beep;
};



class MainWin : public QWidget
{
  Q_OBJECT

 private:
  CmdLine *cmd_in;
  QMultiLineEdit *shouts;
  Child *xBoard;
  QListBox *play, *game;
  QWidget *play_win, *game_win, *idleWidget, *opt_win;
  QLineEdit *idleEd;

  QCheckBox *auto_salut, *login_salut, *beep_on_salut, *beep_on_idle_tell;
  
  info inf;
  int logsal;
  
  
  int g_wait_update, 
    p_wait_update, Fics,
    idle;
  QString g_sel, p_sel;

 public:
  MainWin( char **argv, QWidget *parent=0, const char *name="MainWin" );
  ~MainWin();

 protected:  void timerEvent( QTimerEvent * );
  void keyEvent( QKeyEvent * );
  void parse( QString str );
 
  protected slots:
    void sendCommand();
    void playerList();
    void gameList();
    void play_update();
    void game_update();
    void play_close();
    void game_close();
    void p_select(int);
    void g_select(int);
    void make_match();
    void p_observe();
    void g_observe();
    void xfinger();
    void closeIdle();
    void idleWin();
    void options();
    void closeOpt();
    void setOpt();
    
};

#endif









